% APRENDIZAJE AUTOMÁTICO (G. Pajares y J.M. de la Cruz, Eds.)
% Editorial: RA-MA
% Capítulo 1: Introducción
% Autores: Jesús Manuel de la Cruz García, Gonzalo Pajares Martinsanz
%
% sc_regr.m
%
% Ejemplo de ajuste de unos puntos mediante una función no lineal
% Ejemplo de la sección 1.4.2 y figura 1.9

%Observaciones
y=[2.7,1,0.4,0.1]'+0.4*rand(4,1);   
x=[-1,0,1,2]';
p=[y,x];                            

% Cálculo de parámetros que minimizan el riesgo empírico
alfa0=[1,1];                           
%alfa = lsqnonlin(@fun6,alfa0,[],[],[],p);
alfa = fminsearch(@fun6b,alfa0,[],p);

% representación gráfica observaciones y predicciones
ye=alfa(1)*exp(-alfa(2).*x);
plot(x,y,'bo',x,ye,'r*'), hold on

% representación gráfica de la función no lineal
xx=-1:.1:3;
yy=alfa(1)*exp(-alfa(2).*xx);
plot(xx,yy,'r:')
xlabel('x'),ylabel('y'),title('Regresión no lineal')